---
layout: layouts/test.njk
class: 1AKIFT
group: A
subject: POS
date: 2021-02-03
points: [6, 10, 8, 8]
grading: "Grading: <16: 5, 16-20: 4, 21-24: 3, 25-28: 2, 29-32: 1"
---

<ol>
  <li>
    <ol>
      <li>Python<br />
        {% YesNoTable 8 %}
{% yes_no_question 'In Python, any block of code creates scope.', 'no' %}
{% yes_no_question 'Python has different versions. Old code may not work
  with newer versions, new code may not work with older versions.',
  'yes' %}
{% yes_no_question 'Execution of all Python programs starts in
  <code>main()</code>.', 'no' %}
{% yes_no_question '<kbd>pip</kbd> allows installing and updating third
  party libraries.', 'yes' %}
{% yes_no_question 'Python code written with VSCodium cannot be edited
  with another editor afterwards.', 'no' %}
{% yes_no_question 'A Python sequence type can be indexed, sliced and
   iterated.', 'yes' %}
{% yes_no_question 'Strings in Python are immutable.', 'yes' %}
{% yes_no_question 'Python lists are immutable.', 'no' %}
        {% endYesNoTable %}
      </li>

      <li>C<br />
        {% YesNoTable 4 %}
{% yes_no_question 'In C, any block of code creates scope.', 'yes' %}
{% yes_no_question 'The entry point of any C program is
    <code>main()</code>.', 'yes' %}
{% yes_no_question 'Clang and gcc are aliases for the same C compiler.',
  'no' %}
{% yes_no_question 'C has different versions and different compilers.
  A program working with one compiler may not work with another
  compiler.', 'yes' %}
        {% endYesNoTable %}
      </li>

    </ol>
  </li>

  <li>What is the output of the following code snippets? Write exactly what the
    output of each snippet is if the snippet is the sole content of a Python
    file. If the output is an error message, it is enough to write “ERROR”.
    If there is no visible output, write "-".
    <div class="grading">2 points for each correct answer.</div>
    <ol>

      <li>
{% highlight "python" %}
def average(a, b, c):
    return (a + b + c) / 3.0
average(4, 2, 3)
{% endhighlight %}
{% answer %}
-
{% endanswer %}
      </li>

      <li>
{% highlight "python" %}
def square(length):
    return length * length
print(square(5))
{% endhighlight %}
{% answer %}
25
{% endanswer %}
      </li>

      <li>
{% highlight "python" %}
s = 'Good luck!'
s.upper()
print(s)
{% endhighlight %}
{% answer %}
Good luck!
{% endanswer %}
      </li>

      <li>
{% highlight "python" %}
sum = lambda x, y: x + y
print (sum (3, 4))
{% endhighlight %}
{% answer %}
7
{% endanswer %}
      </li>

      <li>
{% highlight "python" %}
from collections import namedtuple
Point = namedtuple ('Point', ('x', 'y'))
A = Point(x=2, y=3)
{% endhighlight %}
{% answer %}
-
{% endanswer %}
      </li>
    </ol>
  </li>

  <li>Implement <code>rot13(text)</code> assuming that text only contains
    upper case characters. Use the <code>ord(char)->int</code> and
    <code>chr(i:int)->str</code> functions in your implementation.
    Add a proper docstring in order to receive full points.
{% answer %}
    <div class="grading">
      1 point for correct function signature<br />
      1 point for proper docstring<br />
      1 point for result list<br />
      1 point for for loop<br />
      2 points for correct conditions<br />
      1 point for joining the list<br />
      1 point for returning the correct result<br />
    </div>
{% highlight "python" %}
def rot13(text):
    """Return the input string after returning the characters by 13 places."""
    result = []
    for char in text:
        if 'A' <= char = 'M':
            num = ord(char) + 13
        elif 'N' <= char <= 'Z':
            num = ord(char) - 13
        else:
            num = ord(char)
        result.append(chr(num))
    return "".join(result)
{% endhighlight %}
{% endanswer %}
  </li>

  <li>You're in charge of analyzing CO2 data measured by multiple sensors
    in your company's building. You will get the sensor data weekly,
    one file per sensor. The first analysis you're planning to do is to
    calculate the average CO2 pollution per week for each sensor.

    The data in each file is straightforward. One measurement per line,
    starting with a timestamp, then a comma ",", and then the CO2 value in
    PPM. An input file looks like

<pre>
2022-02-02T19:49,1175
2022-02-02T19:59,1235
2022-02-02T20:09,1481
...
2022-02-02T22:09,753
2022-02-02T22:19,819
</pre>

    Implement a function <code>average_co2(filename: str) -> float</code> that returns
    the average CO2 in the given file.
    Add a proper docstring to receive full points.<br />
{% answer %}
    <div class="grading">
      1 point for correct function signature<br />
      1 point for a proper docstring<br />
      1 points for reading the file<br />
      1 point for correctly splitting the input lines<br />
      1 point for converting the PPM to int<br />
      1 point for correct counter variable<br />
      1 point for correctly summing up the values<br />
      1 for returning the correct result<br />
    </div>
{% highlight "python" %}
def average_co2(filename: str) -> float:
    """
    Return average CO2 from the given file.
    """
    count = 0
    total = 0
    with open(filename) as f:
        for line in f:
            total += int(line.split(',')[-1])
            count += 1
    return total / count
{% endhighlight %}
{% endanswer %}
  </li>
</ol>
